##~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~##
##                                                                                   ##
##  This file forms part of the Underworld geophysics modelling application.         ##
##                                                                                   ##
##  For full license and copyright information, please refer to the LICENSE.md file  ##
##  located at the project root, or contact the authors.                             ##
##                                                                                   ##
##~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~##

"""
This module contains routines relating to swarm type objects.
"""

from _swarm import Swarm
import _weights
from _integration_swarm import IntegrationSwarm, VoronoiIntegrationSwarm, GaussIntegrationSwarm, GaussBorderIntegrationSwarm
from _swarmabstract import SwarmAbstract
from _swarmvariable import SwarmVariable
from _population_control import PopulationControl
import layouts
